/*
 * Memory Debug
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1 $  $Date: 2003/01/11 12:40:09 $
 *
 * Author: David Zambonini
 * ---------------------------------------------------------------------------
 */

#ifndef MEM_DEBUG_INCLUDE_H
#define MEM_DEBUG_INCLUDE_H

#ifdef MEMDEBUG
  #undef MEMDEBUG /*Don't use our own macros - would result in infinite loops*/
#endif

#include <stdio.h>
#include <stdlib.h>
#include <phlib/xl_memdb.h>

/* Memory debugging information structure */
struct mem_db_info_struct
  {
    unsigned long id_tag;
    unsigned long line;
    const char *filename;
    const char *allocator;
    size_t size;
    const char *ptr; 
    struct mem_db_info_struct *last;
    struct mem_db_info_struct *next;
  };

typedef struct mem_db_info_struct mem_db_info;

void set_mem_db_used(void);
void set_mem_db_failure(void);
void set_mem_db_info(mem_db_info*,const char*,size_t,const char*,unsigned long);
void move_mem_db_info(mem_db_info*,mem_db_info*,const char*,size_t,const char*,unsigned long);
void unset_mem_db_info(mem_db_info*);
void check_mem_db_info(mem_db_info*,const char*,unsigned long);

extern const unsigned long max_alloc;

#endif /* MEM_DEBUG_INCLUDE_H */


