/*
 * Copyright 1996-2002 netFluid Technology Ltd
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1.1.1 $  $Date: 2003/01/10 23:16:04 $
 * ---------------------------------------------------------------------------
 */

#include <phlib/memdbinc.h>

/* ------------------------------------------------------------------------- */
/* Debugging version of malloc 
 */
void *
malloc_debug(const char *filename,unsigned line,size_t size)
{
  /* We have used a debugging command */
  set_mem_db_used();

    /* Make sure we can honour the request */
  if( size > max_alloc ) {
    /* We can't.. the size is too big to contain in size_t */
    fprintf(stderr,"malloc size overrun in %s, line %i\n",filename,line);
  } else {
    /* Perform allocation */
    register char *ptr = (char*)malloc( size + sizeof(mem_db_info) );
    if( ptr != NULL ) {
      /* Successful allocation */
      set_mem_db_info((mem_db_info*)ptr,"malloc",size,filename,line);

            /* Reference to free memory of requested size */
      return (void*)(ptr+sizeof(mem_db_info));
    }
  }
  /* Failure to allocate */
  set_mem_db_failure();
  return NULL;
}

/* ------------------------------------------------------------------------- */
/* end */

